#ifndef RANDOM_H
#define RANDOM_H
#include <algorithm>
#include <cmath>
#include <vector>
#include <cstdlib>
#include <limits>
#include <cassert>
//#include <libgen.h>

using namespace std;

#define VERYVERBOSE(X);

#define norm   2.328306549295728e-10
#define m1     4294967087.0
#define m2     4294944443.0
#define a12          1403580.0
#define a13n            810728.0
#define a21             527612.0
#define a23n          1370589.0


class Random {
private:
  double  s10, s11, s12, s20, s21, s22;
  double   MRG32k3a();
 
public:
  long int my_seed; 

  Random() {};

  Random(double arg) {
    s10=s11=s12=s20=s21=s22=arg;}
  void set_seed(double arg) {
    s10=s11=s12=s20=s21=s22=arg;}
  
  double ranU01();
  int ranUint(int i, int j);
  int ran0N(int max_ran) {return ranUint(0,max_ran);};
  /*    
	FUNCTION:      generates a random vector, quick and dirty
	INPUT:         vector dimension
	OUTPUT:        returns pointer to vector, 
	free memory after using the vector
	(SIDE)EFFECTS: none
  */
  long int* generate_array(const int & size);
  /*
   * alternative
   */
  vector<long int> generate_random_vector(const int& size ) {
    vector<long int> V(size);
    generate(V.begin(), V.end(), rand);
    return V;
  }
};
#endif
